//+------------------------------------------------------------------+
//|                                                    SimpleGrid.mq4+ 
//+------------------------------------------------------------------+


#include <stdlib.mqh>
#include <WinUser32.mqh>
#property indicator_chart_window
#property indicator_buffers 0
#property strict

// exported variables
extern string GridStartingPrice = " Start Price to Place Lines ";
extern double GSP = 0.0;
extern int GR = 5; 
extern double GridStep = 5;
extern color  CGL = Gold;
extern color  BGL = Green;
extern color  SGL = Red; 
extern bool ClearAllObjects = False;



// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;
 
 


int init()

{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
    return(0);
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
   
    OnEveryTick7();
    double firstGreater = 0;
    double firstSmaller = 0;
    double min          = -999999999;
    double max          = -999999999;
    double diffsell     = 0;
    double diffbuy      = 0;
    for (int i =ObjectsTotal()-1; i>=0; i--)
    {
      string name = ObjectName(i);
      if (StringSubstr(name,0,4)=="Sell")
      {
         diffsell = Bid - ObjectGet(name,OBJPROP_PRICE1);
            if (diffsell>=0 && diffsell>=min) { min = diffsell; firstSmaller = ObjectGet(name,OBJPROP_PRICE1); }
      }            
      if (StringSubstr(name,0,3)=="Buy")
      {
         diffbuy = ObjectGet(name,OBJPROP_PRICE1) - Bid;
            if (diffbuy>=0 && diffbuy>=max) { max = diffbuy; firstGreater = ObjectGet(name,OBJPROP_PRICE1); }
      }            
   }       
    Comment(DoubleToStr(diffsell,Digits),"   ",DoubleToStr(firstSmaller,Digits),DoubleToStr(diffbuy,Digits),"   ",DoubleToStr(firstGreater,Digits));
    return (0);
       
}

void OnEveryTick7()
{
    PipValue = 1;
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
     CentreGridLine();  
        
  
}
   

void CentreGridLine()
{     
      string objName = "CGL";
      double price = Bid;
      if (GSP>0) price = GSP;
      ObjectDelete(objName);
          ObjectCreate(objName, OBJ_HLINE, 0, Time[0],price);
            ObjectSet(objName, OBJPROP_PRICE1, price);
            ObjectSet(objName, OBJPROP_COLOR,CGL);  
   TradeLine();
   UprBnd();
   LwrBnd();
}


void TradeLine()
  {
   int i;
      double price = Bid;
      if (GSP>0) price = GSP;
   double GridStep1= (GridStep*2);
   double BGSP= (price+((GridStep/2)*PipValue*Point)) ;
   double SGSP= (price-((GridStep/2)*PipValue*Point));
   double BBGSP= (BGSP-((GridStep*(GR))*PipValue*Point)) ;
   double SSGSP= (SGSP+((GridStep*(GR))*PipValue*Point));  
    
   {
   for(i=0; i<GR;i++)
    {
    fSGL("Sell"+(string)i,BBGSP+GridStep1*i*PipValue*Point);
    }
   }
 
   {
   for(i=0; i<GR;i++)
    {
    fBGL("Buy"+(string)i,SSGSP-GridStep1*i*PipValue*Point);
    }
   }
   
  }
  
  
 void fBGL(string objName, double price)
   {  
   
      ObjectDelete(objName);
      ObjectCreate(objName, OBJ_HLINE, 0, 0, price);
         ObjectSet(objName, OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet(objName, OBJPROP_WIDTH, 1);
         ObjectSet(objName, OBJPROP_COLOR, BGL);
   }
   
 void fSGL(string objName, double price)
   {  
   
      ObjectDelete(objName);
      ObjectCreate(objName, OBJ_HLINE, 0, 0, price);
         ObjectSet(objName, OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet(objName, OBJPROP_WIDTH, 1);
         ObjectSet(objName, OBJPROP_COLOR, SGL);
   }   
   
   
void UprBnd()
{ if (ObjectFind("UPRBND") == (-1) )
{
    double BGSP= (GSP+((GridStep/2)*PipValue*Point)) ;
    double price= (BGSP+((GridStep*(GR))*PipValue*Point)) ;
    string objName = "UPRBND"  ;
    ObjectCreate(objName, OBJ_HLINE, 0, Time[0], price );
    ObjectSet(objName, OBJPROP_PRICE1,price);
    ObjectSet(objName, OBJPROP_COLOR, DodgerBlue);    
    ObjectSet(objName, OBJPROP_WIDTH,3);
}
    
}


void LwrBnd()
{ if (ObjectFind("LWRBND") == (-1) )
{
    double SGSP= (GSP-((GridStep/2)*PipValue*Point));
    double price= (SGSP-((GridStep*(GR))*PipValue*Point));
    string objName = "LWRBND"  ;
    ObjectCreate(objName, OBJ_HLINE, 0, Time[0], price );
    ObjectSet(objName, OBJPROP_PRICE1,price);
    ObjectSet(objName, OBJPROP_COLOR, Tomato);    
    ObjectSet(objName, OBJPROP_WIDTH, 3);
}
 
}
 
int deinit()
{
  if (ClearAllObjects) ObjectsDeleteAll();
    
    return (0);
    
}


//+------------------------------------------------------------------+ 
  
